package visl.rasmus.gui;

import java.awt.Button;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;

import visl.resources.Dict;

public class HighScoreNameDialog extends Dialog {
	protected Label score, position;
	protected TextField name;
	protected TextField country;
	protected Button okb;
	protected boolean isready;

	public HighScoreNameDialog(Frame parent) {
		super(parent, Dict.get("Enter your name for the HighScore!"), true);
		Panel p = new Panel();
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		p.setLayout(gbl);
		c.gridwidth = GridBagConstraints.RELATIVE;
		c.fill = GridBagConstraints.BOTH;
		c.anchor = GridBagConstraints.NORTHWEST;
		c.weightx = 1;
		c.weighty = 1;
		Label l = new Label(Dict.get("Your total score was:"));
		gbl.setConstraints(l, c);
		p.add(l);
		score = new Label("0");
		c.gridwidth = GridBagConstraints.REMAINDER;
		gbl.setConstraints(score, c);
		p.add(score);

		l = new Label(Dict.get("Which gives you position"));
		c.gridwidth = 1;
		gbl.setConstraints(l, c);
		p.add(l);
		position = new Label("0");
		gbl.setConstraints(position, c);
		p.add(position);
		l = new Label(Dict.get("this year."));
		c.gridwidth = GridBagConstraints.REMAINDER;
		gbl.setConstraints(l, c);
		p.add(l);

		l = new Label(Dict.get("Please enter your name:"));
		c.gridwidth = 1;
		gbl.setConstraints(l, c);
		p.add(l);
		name = new TextField(12);
		name.setText(Dict.get("John Doe"));
		c.gridwidth = GridBagConstraints.REMAINDER;
		gbl.setConstraints(name, c);
		p.add(name);

		l = new Label(Dict.get("and your country:"));
		c.gridwidth = 1;
		gbl.setConstraints(l, c);
		p.add(l);
		country = new TextField(2);
		country.setText(Dict.get("GB"));
		c.gridwidth = GridBagConstraints.REMAINDER;
		gbl.setConstraints(country, c);
		p.add(country);

		add("Center", p);

		p = new Panel();
		p.add(new Button(Dict.get("Cancel")));
		okb = new Button(Dict.get("Ok"));
		p.add(okb);
		add("South", p);
		isready = false;
		pack();
		//hide();
	}
	public boolean handleEvent(Event e) {
		if (e.target == okb && e.id == Event.ACTION_EVENT) {
			isready = true;
			hide();
		} else if (
			(e.target instanceof Button && e.id == Event.ACTION_EVENT)
				|| e.id == Event.WINDOW_DESTROY) {
			name.setText("");
			isready = true;
			hide();
		}
		return false;
	}
	public String getName() {
		return name.getText();
	}
	public String getCountry() {
		return country.getText().toUpperCase();
	}
	public void show(int sc, int pos) {
		//we only want to show the dialog once!
		if(isVisible()) {
			return;
		}
		isready = false;
		score.setText("" + sc);
		position.setText("" + pos);
		if (name.getText().equals(""))
			name.setText(Dict.get("John Doe"));
		okb.invalidate();
		show();
		validate();
	}
	public boolean isReady() {
		return isready;
	}
}
