package visl.rasmus.gui;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;

/** Implements a transparent label */
public class TransLabel extends Component {
    public final static int CENTER = 0;
    public final static int LEFT = 1;
    public final static int RIGHT = 2;
    
    
    protected String s;
    protected int align, x, y;
    public TransLabel() {
	this("", CENTER);
    }
    public TransLabel(String s) {
	this(s, CENTER);
    }
    public TransLabel(String s, int align) {
	this.s = s;
	this.align = align;
	x = 0;
	y = 0;
    }
    public void paint(Graphics g) {
	FontMetrics fm = getFontMetrics(getFont());
	if (fm != null) {
	    g.setColor(getForeground());
	    g.setFont(getFont());
	    Dimension d = size();
	    int w = fm.stringWidth(s), h = fm.getHeight();
	    switch (align) {
	    case CENTER:
		g.drawString(s, x+(d.width-w)/2, y+(d.height+h)/2);
		break;
	    case LEFT:
		g.drawString(s, x+2, y+(d.height+h)/2);
		break;
	    case RIGHT:
		g.drawString(s, x+d.width-w-2, y+(d.height+h)/2);
		break;
	    }
	}
    }
    public Dimension preferredSize() {
	FontMetrics fm = getFontMetrics(getFont());
	if (fm != null) {
	    return new Dimension(fm.stringWidth(s)+4, fm.getHeight()+2);
	}
	return new Dimension();
    }
    public int getAlignment() { return align; }
    public String getText() { return s; }
    public void setAlignment(int al) { align = al; }
    public void setText(String label) { s = label; }
    public void move(int x, int y) {
	this.x = x;
	this.y = y;
    }
    public void setLocation(int x, int y) {
	move(x,y);
    }
}

