package visl.rasmus.hitserver.data;

import java.text.SimpleDateFormat;
import java.util.Date;

public class HighScoreItem {
    public int score;
    public String name;
    public String country;
    public Date date;
    public float hitrate;

    public HighScoreItem(String s) {
	try {
	    int ix = s.indexOf("[");
	    // The format is allmost correct
	    String n = s.substring(0,ix);
	    if (n.equals("HighScoreItem")) {
		// The name is ok!
		int jx = s.indexOf(";", ix);
		name = s.substring(ix+1, jx);
		ix = jx + 1;
		jx = s.indexOf(";", ix);
		country = s.substring(ix, jx).toUpperCase();
		ix = jx+1;
		jx = s.indexOf(";", ix);
		score = Integer.parseInt(s.substring(ix, jx));
		ix = jx+1;
		jx = s.indexOf(";", ix);
		date = null;
		try {
		    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
		    date = formatter.parse(s.substring(ix,jx));
		} catch (java.text.ParseException e) {
		    // Hopefully never applicable
		}
		ix = jx+1;
		jx = s.indexOf("]", ix);
		hitrate = Float.valueOf(s.substring(ix, jx)).floatValue();
	    } else throw new RuntimeException("Not the correct classname");
	} catch (Exception x) {
	    System.out.println("HighScoreItem:Exception while resolving data: "
			       + x);
	    x.printStackTrace();
	}
    }
    public HighScoreItem(String name, String country, int score, 
			 Date date, float hitrate) {
	this.name = name;
	this.country = country;
	this.score = score;
	this.date = date;
	this.hitrate = hitrate;
    }
    public String toString() {
	SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
	
	return "HighScoreItem["+name+";"+country+";"+score+";"+
	    formatter.format(date)+";"+hitrate+"]";
    }
    public int hashCode() {
	return (int)(score*100+(int)(hitrate));
    }
}
