package visl.rasmus.hitserver.gui;

import java.awt.Button;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Frame;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;

import visl.rasmus.gui.MessageDialog;
 
public class AddFunctionDialog extends Dialog {
    protected TextField shrt, lng;
    protected Frame parent;
    protected Button b_ok;

    public AddFunctionDialog(Frame parent) {
	super(parent, "Add Function", true);
	this.parent = parent;
	Panel p = null;
	Label l = null;
	Button b = null;
	
	p = new Panel();
	TextArea ta = new TextArea(3,60);
	ta.setText("Please enter both a short (unique) identifier\n"+
		   "and the name of the function you wish to add.");
	ta.setEditable(false);
	p.add(ta);
	add("North", p);
	
	p = new Panel();
	l = new Label("Short: ");
	p.add(l);
	shrt = new TextField(5);
	p.add(shrt);
	l = new Label("Long: ");
	p.add(l);
	lng = new TextField(20);
	p.add(lng);
	add("Center", p);
	p = new Panel();
	b_ok = new Button("Ok");
	p.add(b_ok);
	b = new Button("Cancel");
	p.add(b);
	add("South", p);
	
    }
    public boolean handleEvent(Event e) {
	if (e.target instanceof Button &&
	    e.id == Event.ACTION_EVENT) {
	    Button b = (Button)e.target;
	    if (b.getLabel().equals("Ok")) {
		if (shrt.getText().equals("") ||
		    lng.getText().equals("")) {
		    MessageDialog md = new MessageDialog(parent, "No data supplied!");
		    md.add("Center", new Label("You have to supply both a short and long description!"));
		    md.pack();
		    md.show();
		    md.dispose();
		    return true;
		}
		hide();
		parent.show();
	    } else {
		shrt.setText("");
		lng.setText("");
		hide();
		parent.show();
	    }
	    return true;
	} else if (e.id == Event.KEY_PRESS && e.key == '\n')
	    postEvent(new Event(b_ok, Event.ACTION_EVENT, null));
	return false;
    }
    public String getShort() {
	if (shrt.getText().equals("")) return null;
	return shrt.getText();
    }
    public String getLong() {
	if (lng.getText().equals("")) return null;
	return lng.getText();
    }
}
