package visl.rasmus.hitserver.gui;

import java.awt.Button;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Frame;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;

import visl.rasmus.gui.MessageDialog;
 
public class AddLanguageDialog extends Dialog {
    protected TextField lang;
    protected Frame parent;
    protected Button b_ok;

    public AddLanguageDialog(Frame parent) {
	super(parent, "Add Language", true);
	this.parent = parent;
	Panel p = new Panel();
	Label l = null;
	Button b = null;
	
	TextArea ta = new TextArea(3,60);
	ta.setText("Please enter an (unique) identifier for the language\n"+
		   "you wish to add to the database.");
	ta.setEditable(false);
	p.add(ta);
	add("North", p);

	p = new Panel();
	l = new Label("Language:");
	p.add(l);
	lang = new TextField(5);
	p.add(lang);
	add("Center", p);

	p = new Panel();
	b_ok = new Button("Ok");
	p.add(b_ok);
	b = new Button("Cancel");
	p.add(b);
	add("South", p);
	
    }
    public boolean handleEvent(Event e) {
	if (e.target instanceof Button &&
	    e.id == Event.ACTION_EVENT) {
	    Button b = (Button)e.target;
	    if (b.getLabel().equals("Ok")) {
		if (lang.getText().equals("")) {
		    MessageDialog md = new MessageDialog(parent, "No data supplied!");
		    md.add("Center", new Label("You have to supply a non-empty string to be used as identifier for the language"));
		    md.pack();
		    md.show();
		    md.dispose();
		    return true;
		}
		hide();
		parent.show();
	    } else {
		lang.setText("");
		hide();
		parent.show();
	    }
	    return true;
	} else if (e.id == Event.KEY_PRESS && e.key == '\n') 
	    postEvent(new Event(b_ok, Event.ACTION_EVENT, null));
	return false;
    }
    public String getLanguage() {
	if (lang.getText().equals("")) return null;
	return lang.getText();
    }
}

