package visl.rasmus.resources;

import java.awt.Color;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

/** Holds all the customizable colors
 * @author Rasmus Lock Larsen, MIP, November 2000 */
public class Colors {
    protected static Hashtable colors = new Hashtable();
    protected static Vector gui = new Vector();
    protected static Vector form = new Vector();
    public static void init() {
	Object[][] gui_cols = {
	    {"bg.function", new Color(0, 155, 0) },
	    {"function", new Color(100, 255, 100) },
	    {"form", new Color(150, 150, 255) },
	    {"leaf", new Color(255, 150, 150) },
	    {"field", new Color(255, 255, 150) },
	    {"fadedfunction", new Color(180, 255, 180) },
	    {"fadedform", new Color(200, 200, 255) },
	    {"fadedleaf", new Color(255, 255, 255) },
	    {"text", Color.black },
	    {"border", Color.black },
	    {"border.dependent", new Color(50,100,250) },
	    {"border.kernel", new Color(200,10,10) },
	    {"border.active", new Color(50, 255, 50) },
	    {"sentence", Color.white },
	    {"edges", Color.black },
	    {"grayedges", Color.lightGray },
	    {"background", Color.lightGray },
	    {"foreground", Color.black },
	    {"message", new Color(0,155,0) },
	    {"warning", new Color(255,255,0) },
	    {"exclamation", new Color(155,0,0) }
	};
	Object[][] form_cols = {
	    {"adj", new Color(0,102,0) },
	    {"adv", new Color(255,178,0) }, 
	    {"art", new Color(153,153,0) },
	    {"conj", new Color(123,123,123) },
	    {"infm", new Color(255, 96, 43) },
	    {"intj", new Color(219, 105, 105) },
	    {"n", new Color(0,0,255) },
	    {"num", new Color(0,153,0) },
	    {"prep", new Color(153,0,0) },
	    {"pron", new Color(51,153,255) },
	    {"pro", new Color(51,153,255) },
	    {"prop", new Color(134,0,224) },
	    {"prp", new Color(153,0,0) },
	    {"v", new Color(255,0,0) }
	};
	for(int i = 0; i < gui_cols.length; i++) {
	    gui.addElement(gui_cols[i][0]);
	    colors.put(gui_cols[i][0], gui_cols[i][1]);
	}
	for(int i = 0; i < form_cols.length; i++) {
	    form.addElement(form_cols[i][0]);
	    colors.put(form_cols[i][0], form_cols[i][1]);
	}
    }
    public static Color get(String s) {
	return (Color)colors.get(s);
    }
    public static void set(String s, Color col) {
	colors.put(s, col);
    }
    /** Returns all the colornames registered in the Color database. */
    public static Enumeration getColorNames() { return colors.keys(); }
    /** Returns all the colornames for GUI attributes */
    public static Enumeration getGUINames() { return gui.elements(); }
    /** Returns all the colornames for form attributes */
    public static Enumeration getFormNames() { return form.elements(); }
}




