package visl.rasmus.resources;

import java.awt.Font;
import java.util.Enumeration;
import java.util.Hashtable;

/**
* Encapsulates miscellaneous preferences objects (Colors, fonts, etc.).
* Not localizable.
* @author Rasmus Lock Larsen
*/
public class Miscellaneous {
	/**
	 * Table of localized objects.
	 * Contains ("Key", Localized Object) pairs.
	 */
	static Hashtable misc;
	/**
	* A variable containing the base of the help file.
	*/
	static String helpBase = "http://visl.sdu.dk/java/games/docs/";

	/** Default localization. */
	public static void localize() {
		Object[][] o = {
		};
		initTables(o);
		Colors.init();
	}

	/** Localization with help base. */
	public static void localize(String helpBase) {
		Miscellaneous.helpBase = helpBase;
		localize();
	}

	/**
	* Default preferences.
	*/
	static void init() {
		Object[][] defaults =
			{ { "scrollfont", new Font("Helvetica", Font.BOLD, 18)}, {
				"dropfont", new Font("Helvetica", Font.BOLD, 16)
				}, {
				"dropsmallfont", new Font("Helvetica", Font.BOLD, 12)
				}, {
				"font.wordfall.formbox", new Font("Helvetica", Font.BOLD, 18)
				}, {
				"url.shoot.help",
					helpBase+"shoot-help.html" },
					{
				"url.syntris.help",
					helpBase+"syntris-help.html" }
		};
		for (int i = 0; i < defaults.length; i++)
			misc.put(defaults[i][0], defaults[i][1]);
	}

	/**
	* Get a localized Object.
	*@param key Key string.
	*@return Localized Object. Or null if there is no local version.
	*/
	public static Object get(String key) {
		return misc.get(key);
	}

	/**
	* Set a key,value pair.
	*/
	public static void set(String key, Object value) {
		misc.put(key, value);
	}

	/**
	* Initialize tables.
	* Called by the localize method.
	*@param m Array of {"Key", Localized Object} pairs.
	*/
	static void initTables(Object[][] m) {
		misc = new Hashtable();
		init();
		for (int i = 0; i < m.length; i++)
			misc.put(m[i][0], m[i][1]);
	}
	public static Enumeration getNames() {
		return misc.keys();
	}
}
