package visl.rasmus.utils;

public class QSortAlgorithm {
   
    static public void swap(Comparable a[], int i, int j) {
	//System.out.println("  swapping "+i+" to "+j+" ("+a[i]+"->"+a[j]+")");
	Comparable T = a[i];
	a[i] = a[j];
	a[j] = T;
    }
    static public void swap(int a[], int i, int j) {
	int T = a[i];
	a[i] = a[j];
	a[j] = T;
    }
    /**
     * Uses quick sort to sort the array between the specified
     * indices
     */
    static protected void sort(Comparable a[], int lo0, int hi0, 
			       int indicies[]) {
	//System.out.print("sort( ");
	//for (int i = 0; i < a.length;i++)
	//    System.out.print(a[i]+" ");
	//System.out.println(","+lo0+","+hi0+")");
	int lo = lo0;
	int hi = hi0;
	if (lo >= hi) {
	    return;
	}
	int mi = (lo+hi)/2;
	Comparable mid = a[mi];
	//System.out.println("+ mid = " + mid + " (index " + ((lo+hi)/2) +")");
	swap(a, mi, hi0);
	hi--;
	while (lo < hi) {
	    while (lo < hi && a[lo].compareTo(mid) <= 0) {
		lo++;
	    }
	    while (lo < hi && a[hi].compareTo(mid) >= 0) {
		hi--;
	    }
	    if (lo <= hi) {
		if (indicies != null) {
		    swap(indicies, lo, hi);
		}
		swap(a, lo, hi);
		lo++;
		hi--;
	    } 
	}
	// Swap the pivot element back
	if (a[lo].compareTo(mid) > 0) {
	    swap(a, hi0, lo);
	    if (indicies != null) swap(indicies, hi0, lo);
	}
	sort(a, lo0, lo-1, indicies);
	sort(a, lo+1, hi0, indicies);
    }
    /**
     * Sorts the given array using the quicksort algorithm.
     */
    public static void sort(Comparable a[], int indices[]) {
	sort(a, 0, a.length-1, indices);
    } 
    static public void main(String argv[]) {
	String arr[] = {"a", "b", "e","k","a","t"};
	System.out.print("Sorting ");
	for (int i = 0; i < arr.length; i++) System.out.print(arr[i]);
	System.out.println();
	sort(arr, null);
	System.out.print("After sort: ");
	for (int i = 0; i < arr.length; i++) System.out.print(arr[i]);
	System.out.println();
    }
}
