/*
 * Created on 02-07-2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package visl.resources;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
/**
 * @author Jens Brask
 */
public class ShortToLong {

	static Hashtable forms, formsAR;
	static Hashtable shortLongAr, shortLongEn;
	/**This Array is tied to the java1_3languages variable in the /home/httpd/html/global/edutainment/games/vars.php file. It should be given as a parameter but I do not know how.
	 */
	static String[] java1_3Languages = { "ar", "grc", "lv", "ru", "jpn" };

	//	static String url;

	/**	
	 * Initializes tables.
	 */
	public static void localize() {
		String[][] defaultforms = { { "n", Dict.get("nouns")}, {
				"v", Dict.get("verbs")
				}, {
				"adj", Dict.get("adjectives")
				}, {
				"adv", Dict.get("adverbs")
				}, {
				"art", Dict.get("articles")
				}, {
				"pron", Dict.get("pronouns")
				}, {
				"prp", Dict.get("prepositions")
				}, {
				"conj", Dict.get("conjunctions")
				}, {
				"infm", Dict.get("infinitive markers")
				}, {
				"num", Dict.get("numerals")
				}, {
				"intj", Dict.get("interjections")
				}, {
				"T100Y", "This year's top 100 scores!" }, {
				"T100M", "This month's top 100 scores!" }, {
				"T10W", "This week's top 10 scores!" }, {
				"T10D", "The top 10 scores in the last 24 hours!" }
		};
		initTables(defaultforms);
	}

	/**
	 * Read translations from url.
	 *@param formUrl url to read translations from.
	 *@exception MalformedURLException if any of the URL
	 */
	public static void localize(String formUrl)
		throws MalformedURLException, IOException {
		localize();
		String[][] form = Dict.readSet(formUrl);
		addToTables(form);
	}

	/**
	 * Read translations from url.
	 *@param formUrl url to read translations from.
	 *@exception MalformedURLException if any of the URL
	 */
	public static void localizeArabic(String formUrl)
		throws MalformedURLException, IOException {
		String[][] form = readArabicSet(formUrl);
		formsAR = new Hashtable();
		for (int i = 0; i < form.length; i++) {
			try {
				formsAR.put(
					new String(form[i][0].getBytes(), "UTF-8"),
					new String(form[i][1].getBytes(), "UTF-8"));
			} catch (java.io.UnsupportedEncodingException UE) {
				UE.printStackTrace();
			}
		}
	}

	public static void localizeArabic(
		String arSLUrl,
		String enSLUrl,
		String transUrl)
		throws MalformedURLException, IOException {
		localizeArabic(transUrl);
		String[][] transAR = readArabicSet(arSLUrl);
		String[][] transEN = readArabicSet(enSLUrl);
		shortLongAr = new Hashtable();
		shortLongEn = new Hashtable();
		for (int i = 0; i < transAR.length; i++) {
			shortLongAr.put(transAR[i][0], transAR[i][1]);
		}
		for (int i = 0; i < transEN.length; i++) {
			shortLongEn.put(transEN[i][0], transEN[i][1]);
		}
	}

	/**
	 * Initialize tables.
	 * Called by the localize method.
	 *@param dict Array of {"English string", "localized string"} dictionary pairs.
	 */
	static private void initTables(String[][] form) {
		forms = new Hashtable();
		for (int i = 0; i < form.length; i++) {
			try {
				forms.put(
					new String(form[i][0].getBytes(), "UTF-8"),
					new String(form[i][1].getBytes(), "UTF-8"));
			} catch (java.io.UnsupportedEncodingException UE) {
				System.err.println(UE.getMessage());
			}
		}
	}

	static private void addToTables(String[][] form) {
		for (int i = 0; i < form.length; i++) {
			try {
				forms.put(
					new String(form[i][0].getBytes(), "UTF-8"),
					new String(form[i][1].getBytes(), "UTF-8"));
			} catch (java.io.UnsupportedEncodingException UE) {
				System.err.println(UE.getMessage());
			}
		}
	}

	static public boolean isInitialized() {
		return forms != null || formsAR != null;
	}

	static public Enumeration getArabicForms() {
		return formsAR.keys();
	}

	static public Enumeration getEnglishForms() {
		return formsAR.elements();
	}

	/**
	 * Get a transformed name from a short name.
	 *@param key short form to get a long form.
	 *@return translated short form (english).
	 */
	public static String get(String key) {
		Object o = null;
		if (forms!=null)
			o = forms.get(key);
		return (o != null)?(String) o:key;
	}
	/**
	 * Get a translated name from a short arabic name.
	 *@param key short form to get a english short form.
	 *@return translated short form (english).
	 */
	public static String getTrans(String key) {
	    Object o = null;
	    if(formsAR != null)
		o = formsAR.get(key);
	    return (o != null) ? (String) o : key;
	}
	/**
	 * Get a long name from a short name.
	 *@param key short form to get a long form.
	 *@return arabic long form from arabic short form or english longform from english short form. Or short form if there is no long form version.
	 */
	public static String getLong(String key) {
		Object o = shortLongAr.get(key);
		if (o == null) {
			o = shortLongEn.get(key);
		}
		if (o == null)
			return key;
		return (String) o;
	}

	/**
	 * Read a name=value set from an url
	 * Format of the file pointed to: ({English text}'='{localized text}'\n')*
	 */
	public static String[][] readArabicSet(String url)
		throws MalformedURLException, IOException {
		return readArabicSet(new URL(url));
	}

	/**
	 * Read a name=value set from an url
	 * Format of the file pointed to: ({English text}'='{Localized text}'\n')*
	 */
	public static String[][] readArabicSet(URL url)
		throws MalformedURLException, IOException {
		Vector set = new Vector();
		String s = null;
		BufferedReader d = null;
		d = new BufferedReader(new InputStreamReader(url.openStream()));
		// use a BufferedReader for input.
		//DataInputStream d = new DataInputStream(url.openStream());
		s = d.readLine(); // read the first line
		String abbr = "", full = ""; // abbreviated and full name of symbol
		int equ; // position of the '=' character
		int linenum = 1;
		while (s != null) { // while not EOF
			equ = s.indexOf('=');
			if (s.startsWith("//")) {
				//DebugFrame.get().addInfo(linenum + ":comment!");
			} else if (equ != -1) {
				full = s.substring(0, equ);
				abbr = s.substring(equ + 1, s.length());
				// Add the (abbr,full name) pair to the set of symbols
				if (full.length() > 0) {
					set.addElement(new String[] { abbr, full });
					//DebugFrame.get().writeSet(abbr, full);
				}
			} else {
				// DebugFrame.get().addInfo(linenum + ":no input!");
			}
			s = d.readLine(); // read the next line.
			linenum++;
		}

		int n = set.size(); // number of symbols
		String[][] symbols = new String[n][];
		for (int i = 0; i < n; i++) {
			symbols[i] = (String[]) set.elementAt(i);
		}
		return symbols;
	}
	static public boolean isJava1_3Languages(String lang) {
		for (int i = 0; i < java1_3Languages.length; i++) {
			if (java1_3Languages[i].equals(lang)) {
				return true;
			}
		}
		return false;
	}

}
