package visl.wordfall.resources;

import java.awt.Color;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

/** Holds all the customizable colors
 * @author Rasmus Lock Larsen, MIP, November 2000 */
public class Colors {
    protected static Hashtable colors = new Hashtable();
    protected static Vector gui = new Vector();
    protected static Vector form = new Vector();
    public static void init() {
	Object[][] gui_cols = {
	    {"formbox", Color.black },
	    {"formbox.highlight", new Color(200,200,200) },
	    {"formbox.inactive", new Color(50,50,50) },
	    {"formbox.error", Color.green},
	    {"fallword.hasfalled", Color.gray },
	    {"fallword.highlight", new Color(120,120,255) },
	    {"word.ok", Color.green },
	    {"word.fault", Color.red },
	};
	Object[][] form_cols = {
	    {"adj", new Color(0,102,0) },
	    {"adv", new Color(255,178,0) }, 
	    {"adp", new Color(153,0,0) },
	    {"art", new Color(153,153,0) },
	    {"det", new Color(153,153,0) },
	    {"conj", new Color(123,123,123) },
	    {"conj-s", new Color(123,123,123) },
	    {"conj-c", new Color(123,123,123) },
	    {"subj", new Color(123,123,123) },
	    {"infm", new Color(255, 96, 43) },
	    {"intj", new Color(219, 105, 105) },
	    {"n", new Color(0,0,255) },
	    {"num", new Color(0,153,0) },
	    {"prep", new Color(153,0,0) },
	    {"part", new Color(153,0,0) },
	    {"pron", new Color(51,153,255) },
	    {"pro", new Color(51,153,255) },
	    {"prop", new Color(134,0,224) },
	    {"prp", new Color(153,0,0) },
	    {"v", new Color(255,0,0) },
	    {"n-adj", new Color(0,0,255) },
	    {"n-adv", new Color(153,0,0) }, 
	    {"g-id", new Color(123,123,123) },
	    {"g", new Color(123,123,123) },
	    {"cl-ns", new Color(219, 105, 105) },
	    {"cl-vs", new Color(219, 105, 105) },
	    {"n-indef", new Color(0,0,255) },
	    {"n-def", new Color(0,0, 255) },
	    {"n-dem", new Color(0,0,255) },
	    {"n-rel", new Color(0,0,255) },
	    {"n-pron", new Color(0,0,255) },
	    {"n-ela", new Color(0,0,255) },
	    {"n-int", new Color(0,0,255) },
	    {"v-per", new Color(255,0,0) },
	    {"v-imp", new Color(255,0,0)},
	    {"v-sub", new Color(255,0,0) },
	    {"v-jus", new Color(255,0,0) },
	    {"v-amr", new Color(255,0,0)},
	    {"xxx", new Color(255,255,255)}
	};
	for(int i = 0; i < gui_cols.length; i++) {
	    gui.addElement(gui_cols[i][0]);
	    colors.put(gui_cols[i][0], gui_cols[i][1]);
	}
	for(int i = 0; i < form_cols.length; i++) {
	    form.addElement(form_cols[i][0]);
	    colors.put(form_cols[i][0], form_cols[i][1]);
	}
    }
    public static Color get(String s) {
        if (s == null || s.equals("")) {
            return null;
        }
        if (colors.containsKey(s)) {
            System.out.println(s);
            return (Color)colors.get(s);	
        } else {
            form.addElement(s);
            colors.put(s, new Color(255,255,255));
            System.out.println(s);
            return (Color)colors.get(s);
        }
    }
    public static void set(String s, Color col) {
	colors.put(s, col);
    }
    /** Returns all the colornames registered in the Color database. */
    public static Enumeration getColorNames() { return colors.keys(); }
    /** Returns all the colornames for GUI attributes */
    public static Enumeration getGUINames() { return gui.elements(); }
    /** Returns all the colornames for form attributes */
    public static Enumeration getFormNames() { return form.elements(); }
}




